import random
import time

list = []
for i in range(101):
    dane = random.randint(100000,999999)
    list.append(dane)
print("Liczba elementów wynosi",i)

####################################################################
def insertion_sort(bucket):
    for i in range (1, len (bucket)):
        var = bucket[i]
        j = i - 1
        while (j >= 0 and var < bucket[j]):
            bucket[j + 1] = bucket[j]
            j = j - 1
        bucket[j + 1] = var

def bucket_sort(input_list):
    start_time = time.time()
    max_value = max(input_list)
    size = max_value / len(input_list)

    buckets_list = []
    for x in range(len(input_list)):
        buckets_list.append([])

    for i in range(len(input_list)):
        j = int(input_list[i] / size)
        if j != len(input_list):
            buckets_list[j].append(input_list[i])
        else:
            buckets_list[len(input_list) - 1].append(input_list[i])

    for z in range(len(input_list)):
        insertion_sort(buckets_list[z])

    final_output = []
    for x in range(len(input_list)):
        final_output = final_output + buckets_list[x]
    elapsed_time = time.time() - start_time
    print("Sortowanie algorytmem kubełkowym", elapsed_time)
    return final_output
####################################################################


def partition(array, begin, end):
    pivot = begin
    for i in range(begin+1, end+1):
        if array[i] <= array[begin]:
            pivot += 1
            array[i], array[pivot] = array[pivot], array[i]
    array[pivot], array[begin] = array[begin], array[pivot]
    return pivot


def _quicksort(array, begin, end):
    if begin >= end:
        return
    pivot = partition(array, begin, end)
    _quicksort(array, begin, pivot-1)
    _quicksort(array, pivot+1, end)


def quicksort(array, begin=0, end=None):
    if end is None:
        end = len(array) - 1
    return _quicksort(array, begin, end)

####################################################################


def bubble_sort(list):
    start_time = time.time()
    n = len(list)
    while n > 1:
        switch = False
        for l in range(0, n - 1):
            if list[l] > list[l + 1]:
                list[l], list[l + 1] = list[l + 1], list[l]
                switch = True
        n -= 1
        if switch == False: break
    elapsed_time = time.time() - start_time
    print("Sortowanie algorytmem bąbelkowym",elapsed_time)
    return list
####################################################################


list_1 = bucket_sort(list)

list_2 = bubble_sort(list)


start_time = time.time()
quicksort(list)
elapsed_time = time.time() - start_time
print("Sortowanie algorytmem quicksort",elapsed_time)